/*
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2007 Sun Microsystems, Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution, if
 *    any, must include the following acknowlegement:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowlegement may appear in the software itself,
 *    if and wherever such third-party acknowlegements normally appear.
 *
 * 4. The names "The Jakarta Project", "Tomcat", and "Apache Software
 *    Foundation" must not be used to endorse or promote products derived
 *    from this software without prior written permission. For written
 *    permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache"
 *    nor may "Apache" appear in their names without prior written
 *    permission of the Apache Group.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * The original contributor of this 
 *
 */
/* Generated By:JavaCC: Do not edit this line. ELParserConstants.java */
package org.netbeans.microedition.databinding.el.parser;

public interface ELParserConstants {

  int EOF = 0;
  int INTEGER_LITERAL = 5;
  int FLOATING_POINT_LITERAL = 6;
  int EXPONENT = 7;
  int STRING_LITERAL = 8;
  int BADLY_ESCAPED_STRING_LITERAL = 9;
  int TRUE = 10;
  int FALSE = 11;
  int NULL = 12;
  int END_EXPRESSION = 13;
  int DOT = 14;
  int GT1 = 15;
  int GT2 = 16;
  int LT1 = 17;
  int LT2 = 18;
  int EQ1 = 19;
  int EQ2 = 20;
  int LE1 = 21;
  int LE2 = 22;
  int GE1 = 23;
  int GE2 = 24;
  int NE1 = 25;
  int NE2 = 26;
  int LPAREN = 27;
  int RPAREN = 28;
  int COMMA = 29;
  int COLON = 30;
  int LBRACKET = 31;
  int RBRACKET = 32;
  int PLUS = 33;
  int MINUS = 34;
  int MULTIPLY = 35;
  int DIVIDE1 = 36;
  int DIVIDE2 = 37;
  int MODULUS1 = 38;
  int MODULUS2 = 39;
  int NOT1 = 40;
  int NOT2 = 41;
  int AND1 = 42;
  int AND2 = 43;
  int OR1 = 44;
  int OR2 = 45;
  int EMPTY = 46;
  int IDENTIFIER = 47;
  int IMPL_OBJ_START = 48;
  int LETTER = 49;
  int DIGIT = 50;
  int ILLEGAL_CHARACTER = 51;

  int DEFAULT = 0;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "<INTEGER_LITERAL>",
    "<FLOATING_POINT_LITERAL>",
    "<EXPONENT>",
    "<STRING_LITERAL>",
    "<BADLY_ESCAPED_STRING_LITERAL>",
    "\"true\"",
    "\"false\"",
    "\"null\"",
    "\"}\"",
    "\".\"",
    "\">\"",
    "\"gt\"",
    "\"<\"",
    "\"lt\"",
    "\"==\"",
    "\"eq\"",
    "\"<=\"",
    "\"le\"",
    "\">=\"",
    "\"ge\"",
    "\"!=\"",
    "\"ne\"",
    "\"(\"",
    "\")\"",
    "\",\"",
    "\":\"",
    "\"[\"",
    "\"]\"",
    "\"+\"",
    "\"-\"",
    "\"*\"",
    "\"/\"",
    "\"div\"",
    "\"%\"",
    "\"mod\"",
    "\"not\"",
    "\"!\"",
    "\"and\"",
    "\"&&\"",
    "\"or\"",
    "\"||\"",
    "\"empty\"",
    "<IDENTIFIER>",
    "\"#\"",
    "<LETTER>",
    "<DIGIT>",
    "<ILLEGAL_CHARACTER>",
  };

}
